Codeforces Round #265 (Div. 2)

来源:互联网 发布:域名和商标的区别 编辑:程序博客网 时间:2024/06/04 20:46

以后做完题及时写blog,再拖拖拉拉剁手!


D. Restore Cube

题意:给8组数据,每组3个数,判断能不能通过改变3个数顺序,使得8组数据构成一个正方体。

解:直接暴力写的,毫无美感。。。还wa了一次。。。3个数有6种组合顺序,深度是8,最多枚举6^8次,大约是10^6,可以水过。关于判断是否构成正方体,对于正方体的每一顶点都满足有3个点到它的距离为a,有3个点到它的距离为sqrt(2)*a,有一个点到它的距离为sqrt(3)*a;


#include <cstdlib>#include <cctype>#include <cstring>#include <cstdio>#include <cmath>#include <algorithm>#include <vector>#include <string>#include <iostream>#include <sstream>#include <map>#include <set>#include <queue>#include <stack>#include <fstream>#include <numeric>#include <iomanip>#include <bitset>#include <list>#include <stdexcept>#include <functional>#include <utility>#include <ctime>using namespace std;#define PB push_back#define MP make_pair#define REP(i,n) for(i=0;i<(n);++i)#define FOR(i,l,h) for(i=(l);i<=(h);++i)#define FORD(i,h,l) for(i=(h);i>=(l);--i)typedef long long LL;const int INF = 0x7fffffff;const double eps = 1e-8;const int N = 1024;const int MOD = 1e9+7;struct node {    int x, y, z;    node() {};    node(int x, int y, int z) : x(x), y(y), z(z) {}    bool operator == (const node& b) {        return (this->x == b.x && this->y == b.y && this->z == b.z);    }};node nd[8], res[8];double len[8];bool flag;int cube[8][3];double dis(node a, node b) {    return double(a.x - b.x)*(a.x - b.x) + double(a.y - b.y)*(a.y - b.y) + double(a.z - b.z)*(a.z - b.z);}bool CK(int k) {    int i, j;    for(j = 0; j < 8; ++j) {        len[j] = dis(nd[k], nd[j]);    }    sort(len, len+8);    for(i = 4; i <= 6; ++i) {        if(len[i] != len[1] + len[1])   return false;    }    if(len[7] != 3*len[1])  return false;    return true;}bool check() {    for(int i = 0; i < 8; ++i) {        if(!CK(i))  return false;    }    return true;}void dfs(int dep) {    if(flag)    return ;    if(dep == 8) {        if(check()) {            flag = true;            for(int i = 0; i < 8; ++i) {                res[i] = nd[i];            }        }        return ;    }    int i, j, k;    for(i = 0; i < 3; ++i) {        for(j = 0; j < 3; ++j) {            if(i == j)  continue;            for(k = 0; k < 3; ++k) {                if(k == j || k == i)    continue;                nd[dep].x = cube[dep][i];                nd[dep].y = cube[dep][j];                nd[dep].z = cube[dep][k];                int xx, yy;                for(xx = 0; xx <= dep; ++xx) {                    for(yy = 0; yy <= dep; ++yy) {                        if(xx == yy)    continue;                        if(nd[xx] == nd[yy])    break;                    }                    if(yy <= dep)    break;                }                if(xx <= dep)    continue;                dfs(dep + 1);                nd[dep].x = nd[dep].y = nd[dep].z = 0;            }        }    }}int main() {    //freopen("data.in", "r", stdin);    int i, j;    for(i = 0; i < 8; ++i) {        for(j = 0; j < 3; ++j) {            scanf("%d", &cube[i][j]);        }    }    memset(nd, 0, sizeof(nd));    flag = false;    dfs(0);    if(!flag)   puts("NO");    else {        puts("YES");        for(i = 0; i < 8; ++i) {            printf("%d %d %d\n", res[i].x, res[i].y, res[i].z);        }    }    return 0;}



E. Substitutes in Number

题意:给一个长度为n的数字串,给一组替换规则,替换规则格式为某个数字对应某个数字串,比如1->000,求被所有的替换规则改变以后的数字串对1e9+7取模的结果。

解:利用进制转换的思想,十进制数1024可以表示为1*1000 + 0*100 + 2*10 + 4。暂时称ai*10^i这个柿子中10为进制数,ai为系数。那么,对于某个数字进行替换的时候对应的进制就会有所改变,系数也会有所改变。

比如数据1:

22222->00->7
0对应的系数变为7,进制为10^0。根据传递性,2对应的系数也变为7,进制数为10^0;

在比如数据2:

12312312->00
2对应的系数为0,进制数为10^2。


基本思路是在替换之前计算出0-9每个数字替换规则对1e9+7取模后的系数和进制数,然后对原数字串进行替换。

ps:替换规则计算时需要从后往前计算,因为后面的替换会对前面造成影响,比如数据1。

#include <cstdlib>#include <cctype>#include <cstring>#include <cstdio>#include <cmath>#include <algorithm>#include <vector>#include <string>#include <iostream>#include <sstream>#include <map>#include <set>#include <queue>#include <stack>#include <fstream>#include <numeric>#include <iomanip>#include <bitset>#include <list>#include <stdexcept>#include <functional>#include <utility>#include <ctime>using namespace std;#define PB push_back#define MP make_pair#define REP(i,n) for(i=0;i<(n);++i)#define FOR(i,l,h) for(i=(l);i<=(h);++i)#define FORD(i,h,l) for(i=(h);i>=(l);--i)typedef long long LL;const int INF = 0x7fffffff;const double eps = 1e-8;const int N = 1024;const int MOD = 1e9+7;string rp[100010];string S;string rd;string ti;int bi[100010];long long p10[11];long long val[11];int main() {    //freopen("data.in", "r", stdin);    cin >> S;    int n;    size_t i;    cin >> n;    memset(bi, -1, sizeof(bi));    for(int j = 0; j < n; ++j) {        cin >> rd;        bi[j] = rd[0] - '0';        for(i = 3; i < rd.size(); ++i) {             rp[j] += rd[i];        }        //cout << rp[bi[j]] << endl;    }    for(int j = 0; j < 10; ++j) {        p10[j] = 10;        val[j] = j;    }    for(int j = n - 1; j >= 0; --j) {        long long newp10 = 1;        long long newval = 0;        int b = bi[j];        for(i = 0; i < rp[j].size(); ++i) {            int x = rp[j][i] - '0';            newp10 = (newp10*p10[x]) % MOD;            newval = (newval*p10[x] + val[x]) % MOD;        }        p10[b] = newp10;        val[b] = newval;    }    long long res = 0;    for(i = 0; i < S.size(); ++i) {        res = (res*p10[S[i] - '0'] + val[S[i] - '0']) % MOD;    }    cout << res << endl;    return 0;}



ps:被完虐啊有木有!好久没刷题了啊有木有!再这么菜b下去就剁手!



0 0
原创粉丝点击